/// File : debugapi.h
/// Purpose : Contains debug fonctions, overrides printfs and puts
#ifndef DEBUGAPI_H
#define DEBUGAPI_H
#ifdef BUILD_DEBUG
#define puts ocrputs
#define printf ocrprintf
#endif
#include "ocrdefs.h"
#include <sys/time.h>

typedef struct timeval timeval;
void critical(_in_ const char *message, ...);
/* Shows failure message and exits
Safe if message is valid*/

int ocrprintf(_in_ const char*, ...);
/* writes in stdout and in log file, safe if parameters are valid*/

int verbose(_in_ const char*, ...);
/* writes only if verbose is enabled or building in debug taget*/

int ocrputs(_in_ const char*);
/* writes in stdout and in log file, safe if parameters are valid*/

timeval init_time();
/* returns current timeval, wich can be used to measure precise time*/

unsigned long timediff(timeval t);
/* returns difference between t and current time in ms*/

void setverbose(bool);
/* enables or disables verbose status*/
#endif
