#include "queue.h"

OCRAPI Queue *createqueue()
{
    Queue *ret = malloc(sizeof(Queue));
    ZeroMemory(ret, sizeof(Queue));
    return ret;
}

OCRAPI void push(Queue *s, void *d)
{
    if(s->last == NULL) //Must be the first one
    {
        s->last = malloc(sizeof(QueueNode));
        s->last->data = d;
        s->first = s->last;
        s->count++;
        return;
    }
    s->last->next = malloc(sizeof(QueueNode));
    ((QueueNode*)s->last->next)->data = d;
    ((QueueNode*)s->last->next)->previous = s->last;
    //No need to set s->last->next->next to NULL
    s->last = s->last->next;
    s->count++;
}

OCRAPI void *pop(Queue *s)
{
#ifdef BUILD_DEBUG
    if(isqueueempty(s))
    {
        critical("pop called on an empty queue");
    }
#endif
    QueueNode *node = s->first;
    void *ret = node->data;
    s->first = node->next;
    s->count--;
    free(node);
    return ret;
}

OCRAPI bool isqueueempty(Queue *s)
{
    return s->count == 0;
}

OCRAPI USHORT queue_count(Queue *s)
{
    return s->count;
}

OCRAPI void freequeue(Queue *q)
{
#ifdef BUILD_DEBUG
    if(!isqueueempty(q))
        printf("Warning : deleting non-empty queue (%u elements )", queue_count(q));
#endif
    free(q);
}
